(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321_1.ogg","321_2.ogg","321_fight.ogg","attack_pikan_1.ogg","attack_pikan_2.ogg","attack_pikan_3.ogg","attack_stick_1.ogg","attack_stick_2.ogg","attack_stick_3.ogg","attack_sword_1.ogg","attack_sword_2.ogg","attack_sword_3.ogg","attack_sword_4.ogg","attack_thor_1.ogg","attack_thor_2.ogg","attack_thor_3.ogg","bomb_fall_sound.ogg","brutality_phase_1.ogg","brutality_phase_2.ogg","butt_level.ogg","butt_menu.ogg","drinking_that_now.ogg","faux.ogg","fight_boss_die_1.ogg","fight_boss_die_2.ogg","fight_boss_die_3.ogg","fight_punch1.ogg","fight_punch2.ogg","fight_punch3.ogg","fight_punch4.ogg","fight_punch5.ogg","fight_punch_boss1.ogg","fight_punch_boss2.ogg","fight_punch_boss_1.ogg","fight_punch_boss_2.ogg","fight_sprotch.ogg","fight_the_boss_1.ogg","fight_the_boss_2.ogg","fight_weapon_broke.ogg","fight_woosh1.ogg","fight_woosh2.ogg","fight_woosh3.ogg","fist_logo_sound.ogg","four_1.ogg","four_2.ogg","four_3.ogg","freeze_time_now.ogg","gameover_healthbarup.ogg","hatchet_fall.ogg","hatchet_in_air.ogg","hit_explode_1.ogg","hit_explode_2.ogg","hit_explode_3.ogg","hit_guitar_1.ogg","hit_guitar_2.ogg","hit_guitar_3.ogg","hit_hammer_2.ogg","hit_hammer_3.ogg","hit_mace_1.ogg","hit_mace_2.ogg","hit_mace_3.ogg","hit_power_1.ogg","hit_power_2.ogg","hit_power_3.ogg","hit_power_4.ogg","hit_power_5.ogg","hit_power_6.ogg","hit_sabre_1.ogg","hit_sabre_2.ogg","hit_sabre_3.ogg","hit_sabre_4.ogg","hit_shuriken_1.ogg","hit_shuriken_2.ogg","hit_shuriken_3.ogg","hit_stick_1.ogg","hit_stick_2.ogg","jackpot.ogg","logo_woosh_sound.ogg","music_critical.ogg","music_ingame.ogg","music_menu.ogg","newrecord.ogg","no_money.ogg","one_1.ogg","one_2.ogg","one_3.ogg","phoenix.ogg","player_attack_perfect.ogg","player_die.ogg","player_hit1.ogg","player_hit2.ogg","player_ya1.ogg","player_ya10.ogg","player_ya11.ogg","player_ya2.ogg","player_ya3.ogg","player_ya4.ogg","player_ya5.ogg","player_ya6.ogg","player_ya7.ogg","player_ya8.ogg","player_ya9.ogg","potion_break.ogg","power_shield_son.ogg","revivalepicburstinyourface.ogg","rise_to_fall.ogg","rotate_enemy.ogg","select_weapon_now.ogg","shop_weapon_sound.ogg","shuriknife_sound.ogg","swordscrape.ogg","test_sound.ogg","three_1.ogg","three_2.ogg","three_3.ogg","throw_knife_1.ogg","throw_knife_2.ogg","throw_knife_3.ogg","throw_knife_4.ogg","throw_that_bomb_1.ogg","throw_that_bomb_2.ogg","throw_thunder_son.ogg","tossing_potion.ogg","two_1.ogg","two_2.ogg","two_3.ogg","victorytoolcoin.ogg","victory_coin.ogg","victory_game_over.ogg","victory_star.ogg","victory_win.ogg","wolfhit.ogg","wolfmode.ogg","wolfshoot.ogg","wrong.ogg","zero_1.ogg","zero_2.ogg","zero_3.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

